#ifndef _SIMLIB
#define _SIMLIB

#include "pexec.h"
typedef struct _SIM_Ctx SIM_Ctx;
struct _SIM_Ctx {
    PX_Ctx *pctx;
    int    wrt_fd;        /* Connected fds */
    int    rd_fd;
    int    listen_fd;     /* For new connections */
    void (*read_callback) ANSI_ARGS((SIM_Ctx *));
    int    rd_ready;
    int    wt_ready;
    };

SIM_Ctx *SIM_Contact ANSI_ARGS(( char *, char * ));
void SIM_ReadCallback ANSI_ARGS(( SIM_Ctx *, void (*)(SIM_Ctx*) ));
void SIM_SendFloats   ANSI_ARGS(( SIM_Ctx *, float *, int ));
void SIM_SendInts     ANSI_ARGS(( SIM_Ctx *, int *, int ));
void SIM_ReadInts     ANSI_ARGS(( SIM_Ctx *, int *, int ));
void SIM_ReadInts     ANSI_ARGS(( SIM_Ctx *, int *, int ));
void SIM_Update       ANSI_ARGS(( SIM_Ctx * ));
void SIM_Close        ANSI_ARGS(( SIM_Ctx * ));

/* Internal routines ... */
int SIM_ReadData      ANSI_ARGS(( PX_Ctx *, PX_Conn *, PX_Handler, int ));
int SIM_GetConnection ANSI_ARGS(( PX_Ctx *, PX_Conn *, PX_Handler, int ));
int SIM_CanWrite      ANSI_ARGS(( PX_Ctx *, PX_Conn *, PX_Handler, int ));
#endif
